#include "Random.hlsl"

struct MyVertexOut
{
  float4 A : TEXCOORD8;
  float4 B : TEXCOORD9;
  float4 C : TEXCOORD10;
  VertexOut vertexOut;
};


MyVertexOut main(VertexIn In, uint id : SV_VertexID)
{
  VertexOut Out = VERTEX_FUNCTION(In);

  Out.ViewSpacePosition = mul(Out.WorldPosition, viewMatrix);
#ifdef COGS_CLIPPING

  Out.Clip0 = float4(dot(clippingPlanes[0], Out.ViewSpacePosition),
                     dot(clippingPlanes[1], Out.ViewSpacePosition),
                     dot(clippingPlanes[2], Out.ViewSpacePosition),
                     dot(clippingPlanes[3], Out.ViewSpacePosition));
  Out.Clip1.xy = float2(dot(clippingPlanes[4], Out.ViewSpacePosition),
                        dot(clippingPlanes[5], Out.ViewSpacePosition));
#ifdef COGS_PIPELINE_CUSTOM_CLIP
  Out.Clip1.z = Out.COGS_PIPELINE_CUSTOM_CLIP;
#endif
#endif

  MyVertexOut MyOut = (MyVertexOut)0;
  MyOut.vertexOut = Out;

  MyOut.A = float4(((id + 0) % 3) == 0,
                   ((id + 1) % 3) == 0,
                   ((id + 2) % 3) == 0,
                   ((id + 0) % 2) == 0);
  MyOut.B = float4(((id + 1) % 2) == 0,
                   ((id + 0) % 5) == 0,
                   ((id + 1) % 5) == 0,
                   ((id + 2) % 5) == 0);
  MyOut.B = float4(((id + 3) % 5) == 0,
                   ((id + 4) % 5) == 0,
                   ((id + 0) % 7) == 0,
                   ((id + 1) % 7) == 0);
  return MyOut;
}
