var MaterialInstance = {
    addFunctions: function (bridge, self) {
        self.setProperty = function (key, value) {
            bridge.SetMaterialInstanceProperty(self, key, value, false);
        };

        self.setTexture = function (key, texture) {
            bridge.SetMaterialInstanceTexture(self, key, texture);
        }

        self.setTextureAddressMode = function (key, mode) {
            // Workaround to translate enum value to name.
            var name = "Clamp";
            for (var i in AddressMode) {
                if (mode[i] == mode) {
                    name = i;
                }
            }

            bridge.SetMaterialInstanceTextureAddressMode(self, key, name);
        }
    },
    create: function (bridge, material, name) {
        var self = {
            id: bridge.LoadMaterialInstance(material),
            name: name,
        };

        MaterialInstance.addFunctions(bridge, self);

        return self;
    },
    createWrapper: function (bridge, id) {
        var self = {
            id: id,
        };

        MaterialInstance.addFunctions(bridge, self);

        return self;
    }
};
