Texture2D colorTexture;
SamplerState linearSampler;

RWStructuredBuffer<float4> toneBuffer;

[numthreads(1, 1, 1)]
void main(uint3 gid : SV_GroupID, uint tix : SV_GroupIndex)
{
  float4 sum = float4(0, 0, 0, 0);
  
  for (int j = 0; j < 10; j++) {
    for (int i = 0; i < 10; i++) {
      float3 col = colorTexture.SampleLevel(linearSampler, float2(0.1 * i, 0.1 * j), 0).rgb;

      sum.rgb += col;
    }
  }

  sum /= 100;

  float3 perceptive = float3(0.2126, 0.7152, 0.0722);
  float inverseToneLightness = 1 / dot(sum.rgb, perceptive);

  toneBuffer[0] = normalize(lerp(toneBuffer[0], float4(sum.rgb * inverseToneLightness, 1), 0.1));
}
