precision highp float;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 worldMatrix;

uniform mat4 textureMatrix;

attribute vec4 a_POSITION0;
attribute vec3 a_NORMAL0;
attribute vec4 a_COLOR0;
attribute vec2 a_TEXCOORD0;

varying vec4 vPosition;
varying vec3 vNormal;
varying vec4 vColor;
varying vec2 vTexCoord;

void main() {
  mat4 worldViewMatrix = viewMatrix * worldMatrix;

  vPosition = worldViewMatrix * a_POSITION0;
  gl_Position = projectionMatrix * vPosition;

#ifdef ENABLE_COLOR
  vColor = a_COLOR0;
#else
  vColor = vec4(1, 1, 1, 1);
#endif

  vNormal = (worldViewMatrix * vec4(a_NORMAL0, 0)).xyz;

#ifdef ENABLE_TEXTURE
  vTexCoord = (textureMatrix * vec4(a_TEXCOORD0, 0, 1)).st;
#endif
}
