void geometryFunction(point VertexIn In[1], inout TriangleStream<VertexOut> OutputStream)
{
  float4 pos = In[0].Position;

  float3 p = (1.0 / pos.w) * pos.xyz;
  float texScale = pointSizes.x * 0.5;

  float2 shift = floor(viewportScale.xy * p.xy);
  float2 center = p.xy + shift;

  VertexOut vertex = (VertexOut)0;
  float2 v0 = (center + float2(-0.5, -0.5) * pointSizes.x) * viewportScale.zw;
  vertex.texCoord = float2(-texScale, texScale);
  vertex.Position = float4(v0, p.z, 1.0);
  OutputStream.Append(vertex);

  float2 v1 = (center + float2(0.5, -0.5) * pointSizes.x) * viewportScale.zw;
  vertex.texCoord = float2(texScale, texScale);
  vertex.Position = float4(v1, p.z, 1.0);
  OutputStream.Append(vertex);

  float2 v2 = (center + float2(-0.5, 0.5) * pointSizes.x) * viewportScale.zw;
  vertex.texCoord = float2(-texScale, -texScale);
  vertex.Position = float4(v2, p.z, 1.0);
  OutputStream.Append(vertex);

  float2 v3 = (center + float2(0.5, 0.5) * pointSizes.x) * viewportScale.zw;
  vertex.texCoord = float2(texScale, -texScale);
  vertex.Position = float4(v3, p.z, 1.0);
  OutputStream.Append(vertex);
}
