VertexOut vertexFunction(in VertexIn vertexIn)
{
  VertexOut vertexOut;

  vec4 cp = worldToClipMatrix*(worldMatrix*vec4(vertexIn.Position.xyz, 1.0));
  vec3 p = (1.0 / cp.w) * cp.xyz;

  vertexOut.texCoord = pointSizes.x * (vec2(vertexIn.Position.w < 0.0 ? 1 : 0, abs(vertexIn.Position.w) < 2.0 ? 1 : 0) - vec2(0.5, 0.5));

  p.xy = floor(viewportScale.xy * p.xy) + vec2(0.5, 0.5) + vertexOut.texCoord;

  vertexOut.Position = vec4(viewportScale.zw * p.xy, p.z, 1.0);

  return vertexOut;
}
