Texture2D colorTexture;
Texture2D occlusionTexture;
Texture2D depthTexture;

SamplerState linearSampler;

struct VertexIn
{
  float4 Position : SV_Position;
  float4 ScreenPosition : TEXCOORD0;
  float2 TexCoords : TEXCOORD1;
};

struct PsOutput
{
  float4 Color : SV_Target;
  float Depth : SV_Depth;
};

cbuffer AoCompositeParameters
{
  float strength;
};

PsOutput main(VertexIn In)
{
  const float4 color = colorTexture.Load(int3(In.Position.xy, 0));
  const float depth = depthTexture.Load(int3(In.Position.xy, 0)).r;
  const float occlusion = occlusionTexture.Sample(linearSampler, In.TexCoords).r;

  PsOutput Out = (PsOutput)0;
  Out.Color = color * lerp(1.0, occlusion, strength);
  Out.Depth = depth;
  return Out;
}
