cbuffer Parameters
{
  float4 color;
  float brightness;
};

Texture2D colorTexture;

float4 main(float4 ScreenPos : SV_Position) : SV_Target
{
  const float4 colorIn = colorTexture.Load(int3(ScreenPos.xy, 0));

  float lightness = saturate(colorIn.r * 0.2126 + colorIn.g * 0.7152 + colorIn.b * 0.0722);

  return float4(brightness * color.rgb * lightness, 1);
}
