#include "AtmosphericScattering.hlsl"

VertexOut vertexFunction(VertexIn In)
{
  VertexOut Out = (VertexOut)0;

  float3 vPositionLocal = In.Position.xyz;
  float3 vPositionEarthCenter = In.Position.xyz;
  vPositionLocal.z -= INNER_RADIUS;
  vPositionLocal = normalize(vPositionLocal) * 100;// FAR_CLIP_PLANE;
  Out.vLocalPosition =  vPositionLocal;

  float4 surfacePositionWorld = mul(float4(vPositionLocal, 1), worldMatrix);
  Out.Position = mul(surfacePositionWorld, worldToClipMatrix);

  ComputeAtmosphericScatteringPerVertexData(vPositionEarthCenter.xzy, Out.vRayleighColor, Out.vMieColor);

  return Out;
}
